{
  "openapi": "3.0.1",
  "info": {
    "title": "Ripple Custody API",
    "version": "",
    "description": "Ripple Custody exposes a complete set of API operations to administer and operate the system programmatically. The below entities are at the core of the system:\r\n- **intents** represent requests to execute an action within the system that may eventually be executed if fully approved;\r\n- **domains** define segregated sets of entities (e.g., users, policies and accounts) with guaranteed isolation from each other;\r\n- **users** are human or technical consumers of the service;\r\n- **policies** are operational rules defining the required (multi-)approval workflow for the execution of particular intents;\r\n- **vaults** are logical key stores responsible for the building and signing of outgoing transactions;\r\n- **accounts** are particular sets of addresses within a vault for which balance(s) and transactions are tracked;\r\n- **transaction orders** are orders to transfer digital assets or request an operation on the ledger;\r\n- **transactions** are incoming or outgoing ledger transactions that have been detected on the ledger or shall be broadcast;\r\n- **transfers** are the financial representation of their corresponding **transactions**;\r\n- **endpoints** associate ledger addresses with human-readable aliases to keep track of whitelisted and blacklisted addresses;\r\n- **ledgers** are accounting systems that are supported and tracked;\r\n- **tickers** define the detected currencies and their respective symbols and parameters;\r\n- **events** are the notification payloads generated through user actions, system signals, and ledger updates.\r\n- **requests** allow to follow the progress of a user request and identify a possible failure.\r\n\r\nBecause the security of digital assets is paramount, Ripple Custody leverages multiple security protocols ensuring a proper management of the keys, of the signature process, of user authentication, of the application of governance policies and overall of data integrity system-wide. Notably, \r\n- every request to mutate the system, as modelled through an **intent**, must be signed by all parties involved, such that an end-to-end secure link is set between the API consumer and the core of Ripple Custody;\r\n- every request to mutate the system is subject to programmable **policies** that regulate the exact quorum of users being authorized to approve and execute the **intent**;\r\n- every critical entity is protected by a data integrity protocol. Entities are versioned and stored as part of a Merkle tree whose root is signed for any mutation of the data. Any data tampering attempt at the database level or in transit is identified and fails at runtime. All such protected entites are wrapped into a `data` envelope and augmented with a `signature` field at the API level to allow a validation of the data integrity from the outside the system. This is particularly relevant to validate, for instance, the integrity of deposit addresses of a given account.\r\n\r\nMost entity types rely on a common pattern exposing the following fields:\r\n - `id`: a user-defined unique identifier (UUID); once defined, an id cannot be modified\r\n - `metadata.revision`: a system-enforced revision number set to 1 for the creation of the entity, and incremented at every entity update\r\n - `metadata.description`: an optional user-defined description of the entity\r\n - `metadata.createdAt`: a system-enforced timestamp marking the creation time of the entity\r\n - `metadata.createdBy`: a system-enforced reference to the creator of the entity\r\n - `metadata.lastModifiedAt`: a system-enforced timestamp marking the last update time of the entity\r\n - `metadata.lastModifiedBy`: a system-enforced reference to the last updater of the entity\r\n - `metadata.customProperties`: a user-defined key-value store to attach arbitrary data to the entity, such as a correlation identifier; customProperties are part of the evaluation context of policies conditions and may be used to trigger particular approval workflows\r\n\r\nTogether, `id` and `metadata.revision` are the basis of the anti-replay model in Ripple Custody.\r\n\r\nMost entities also expose a `lock` flag to make the entity read-only and prevent its use during runtime:\r\n- `lock`: lock status of an entity, which may be `Locked` or `Unlocked`; an `Unlocked` entity inherits the lock of its hierarchical parent and a `Locked` entity (with its dependent entities) may not be used at runtime.\r\n\r\nLocking a **domain** will lock all its inner entities as well as subdomains; locking a **user** will prevent it from submitting any request to the system or to access the service; locking a **policy** will ignore it entirely in the context of the policy selection; locking a **vault** will lock all its related **accounts**; locking an **account** will prevent the execution of transactional operations; locking an **endpoint** will prevent its use as a transaction order destination.\r\n\r\nFor requests returning a list of entities, pagination is enabled by default. The request may include a `limit` parameter to properly quantify the size of the response, a `startingAfter` parameter to define the anchor point, `sortBy` to define a possible sorting property, `sortOrder` to specify the direction of the sorting (resp. \"ASC\", \"DESC\") and possibly filtering criterions that may be entity-specific.\r\n\r\nResponses are packaged within a list of `items` and a pointer to the next page is exposed as property `nextStartingAfter`.\r\n\r\n",
    "x-logo": {
      "url": "images/ripple-custody.png",
      "altText": "Ripple Custody logo"
    },
    "x-app-version": "1.39"
  },
  "paths": {
    "/v1/backups/{backupId}": {
      "get": {
        "tags": [
          "Backups"
        ],
        "summary": "Get Backup information",
        "operationId": "getBackup",
        "parameters": [
          {
            "name": "backupId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ApiBackup"
                }
              }
            }
          },
          "400": {
            "description": "Invalid value for: path parameter backupId",
            "content": {
              "text/plain": {
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Entity or Domain not found (EntityNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/backups": {
      "get": {
        "tags": [
          "Backups"
        ],
        "summary": "List Backups",
        "operationId": "getBackups",
        "parameters": [
          {
            "name": "limit",
            "in": "query",
            "description": "The number of entities to return.",
            "schema": {
              "maximum": 100,
              "minimum": 1,
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "startingAfter",
            "in": "query",
            "description": "Entity id used to the determine beginning of query results.",
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "sortBy",
            "in": "query",
            "description": "Property name used to sort the query results.",
            "schema": {
              "enum": [
                "id",
                "alias",
                "metadata.createdAt",
                "metadata.lastModifiedAt"
              ],
              "type": "string"
            }
          },
          {
            "name": "sortOrder",
            "in": "query",
            "description": "Sort order applied to the query results.",
            "schema": {
              "$ref": "#/components/schemas/Core_SortOrder"
            }
          },
          {
            "name": "vaultId",
            "in": "query",
            "description": "Return entities matching given vault id.",
            "schema": {
              "type": "string",
              "format": "uuid"
            },
            "example": "8e92eb53-40e7-4809-bb52-7e7b3b41a4be"
          },
          {
            "name": "lastOnly",
            "in": "query",
            "description": "Return entities with acknowledged status and limits results to latest one.",
            "schema": {
              "type": "boolean"
            },
            "example": "true"
          },
          {
            "name": "acknowledged",
            "in": "query",
            "description": "Return entities with acknowledged status equals true.",
            "schema": {
              "type": "boolean"
            },
            "example": "true"
          },
          {
            "name": "data.type",
            "in": "query",
            "description": "Return entities that matches given type.",
            "schema": {
              "$ref": "#/components/schemas/Core_BackupType"
            },
            "example": "VaultMpc"
          },
          {
            "name": "metadata.createdBy",
            "in": "query",
            "description": "Return entities that were created by matching user.",
            "schema": {
              "type": "string",
              "format": "uuid"
            },
            "example": "fdeeeb4b-f987-4ec4-9880-1eb280581d49"
          },
          {
            "name": "metadata.lastModifiedBy",
            "in": "query",
            "description": "Return entities that were last modified by matching user.",
            "schema": {
              "type": "string",
              "format": "uuid"
            },
            "example": "90c4cf2f-ebe0-4bf7-91cd-4c45cd02277b"
          },
          {
            "name": "metadata.description",
            "in": "query",
            "description": "Return entities with descriptions that contains or equals to provided description.",
            "schema": {
              "minLength": 0,
              "type": "string"
            },
            "example": "description1"
          },
          {
            "name": "metadata.customProperties",
            "in": "query",
            "description": "Return entities that contains provided custom properties.",
            "schema": {
              "type": "array",
              "items": {
                "type": "string"
              }
            },
            "example": [
              "key1:value1",
              "key2:value2"
            ]
          },
          {
            "name": "additionalDetails.processingStatus",
            "in": "query",
            "description": "Return entities matching given processing status.",
            "schema": {
              "$ref": "#/components/schemas/Core_BackupProcessingStatus"
            },
            "example": "Pending"
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_BackupsCollection"
                }
              }
            }
          },
          "400": {
            "description": "Invalid value for: query parameter limit, Invalid value for: query parameter startingAfter, Invalid value for: query parameter sortBy, Invalid value for: query parameter sortOrder, Invalid value for: query parameter vaultId, Invalid value for: query parameter lastOnly, Invalid value for: query parameter acknowledged, Invalid value for: query parameter data.type, Invalid value for: query parameter metadata.createdBy, Invalid value for: query parameter metadata.lastModifiedBy, Invalid value for: query parameter metadata.description, Invalid value for: query parameter metadata.customProperties, Invalid value for: query parameter additionalDetails.processingStatus",
            "content": {
              "text/plain": {
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Entity or Domain not found (EntityNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/backups/{backupId}/trusted-entity": {
      "get": {
        "tags": [
          "Backups"
        ],
        "summary": "Get Backup trusted entity details",
        "operationId": "getBackupTrustedEntity",
        "parameters": [
          {
            "name": "backupId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ApiTrustedBackup"
                }
              }
            }
          },
          "400": {
            "description": "Invalid value for: path parameter backupId",
            "content": {
              "text/plain": {
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Entity or Domain not found (EntityNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/domains/{domainId}": {
      "get": {
        "tags": [
          "Domains"
        ],
        "summary": "Get domain details",
        "operationId": "getDomain",
        "parameters": [
          {
            "name": "domainId",
            "in": "path",
            "description": "Unique identifier for the domain.",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_TrustedDomain"
                }
              }
            }
          },
          "400": {
            "description": "Invalid value for: path parameter domainId",
            "content": {
              "text/plain": {
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Entity or Domain not found (EntityNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/domains": {
      "get": {
        "tags": [
          "Domains"
        ],
        "summary": "List domains",
        "operationId": "getDomains",
        "parameters": [
          {
            "name": "limit",
            "in": "query",
            "description": "The number of entities to return.",
            "schema": {
              "maximum": 100,
              "minimum": 1,
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "startingAfter",
            "in": "query",
            "description": "Entity id used to the determine beginning of query results.",
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "sortBy",
            "in": "query",
            "description": "Property name used to sort the query results.",
            "schema": {
              "enum": [
                "id",
                "parentId",
                "alias",
                "lock",
                "metadata.createdAt",
                "metadata.lastModifiedAt"
              ],
              "type": "string"
            }
          },
          {
            "name": "sortOrder",
            "in": "query",
            "description": "Sort order applied to the query results.",
            "schema": {
              "$ref": "#/components/schemas/Core_SortOrder"
            }
          },
          {
            "name": "parentId",
            "in": "query",
            "description": "Filter domains based on given parent/root id.",
            "schema": {
              "type": "string",
              "format": "uuid"
            },
            "example": "8e92eb53-40e7-4809-bb52-7e7b3b41a4be"
          },
          {
            "name": "alias",
            "in": "query",
            "description": "Return entities with aliases that contains or equals to provided alias.",
            "schema": {
              "minLength": 1,
              "type": "string"
            },
            "example": "alias1"
          },
          {
            "name": "metadata.createdBy",
            "in": "query",
            "description": "Return entities that were created by matching user.",
            "schema": {
              "type": "string",
              "format": "uuid"
            },
            "example": "fdeeeb4b-f987-4ec4-9880-1eb280581d49"
          },
          {
            "name": "metadata.lastModifiedBy",
            "in": "query",
            "description": "Return entities that were last modified by matching user.",
            "schema": {
              "type": "string",
              "format": "uuid"
            },
            "example": "90c4cf2f-ebe0-4bf7-91cd-4c45cd02277b"
          },
          {
            "name": "metadata.description",
            "in": "query",
            "description": "Return entities with descriptions that contains or equals to provided description.",
            "schema": {
              "minLength": 0,
              "type": "string"
            },
            "example": "description1"
          },
          {
            "name": "metadata.customProperties",
            "in": "query",
            "description": "Return entities that contains provided custom properties.",
            "schema": {
              "type": "array",
              "items": {
                "type": "string"
              }
            },
            "example": [
              "key1:value1",
              "key2:value2"
            ]
          },
          {
            "name": "lock",
            "in": "query",
            "description": "Return entities matching given lock status.",
            "schema": {
              "type": "array",
              "items": {
                "$ref": "#/components/schemas/Core_LockStatus"
              }
            },
            "example": [
              "Locked",
              "Unlocked"
            ]
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_TrustedDomainsCollection"
                }
              }
            }
          },
          "400": {
            "description": "Invalid value for: query parameter limit, Invalid value for: query parameter startingAfter, Invalid value for: query parameter sortBy, Invalid value for: query parameter sortOrder, Invalid value for: query parameter parentId, Invalid value for: query parameter alias, Invalid value for: query parameter metadata.createdBy, Invalid value for: query parameter metadata.lastModifiedBy, Invalid value for: query parameter metadata.description, Invalid value for: query parameter metadata.customProperties, Invalid value for: query parameter lock",
            "content": {
              "text/plain": {
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/vaults": {
      "get": {
        "tags": [
          "Vaults"
        ],
        "summary": "List vaults",
        "operationId": "getVaults",
        "parameters": [
          {
            "name": "limit",
            "in": "query",
            "description": "The number of entities to return.",
            "schema": {
              "maximum": 100,
              "minimum": 1,
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "startingAfter",
            "in": "query",
            "description": "Entity id used to the determine beginning of query results.",
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "sortBy",
            "in": "query",
            "description": "Property name used to sort the query results.",
            "schema": {
              "enum": [
                "id",
                "alias",
                "lock",
                "metadata.createdAt",
                "metadata.lastModifiedAt"
              ],
              "type": "string"
            }
          },
          {
            "name": "sortOrder",
            "in": "query",
            "description": "Sort order applied to the query results.",
            "schema": {
              "$ref": "#/components/schemas/Core_SortOrder"
            }
          },
          {
            "name": "alias",
            "in": "query",
            "description": "Return entities with aliases that contains or equals to provided alias.",
            "schema": {
              "minLength": 1,
              "type": "string"
            },
            "example": "alias1"
          },
          {
            "name": "publicKey",
            "in": "query",
            "description": "Return entities matching given public key. It should be provided in Base64 format.",
            "schema": {
              "minLength": 1,
              "type": "string"
            },
            "example": "MFkwEwYHKoZIzj0CAQYIKoZIzj0DAQcDQgAENYOHIq0Pgg5ERTQOahVK3I45+efvsRvw1rcyk+oqpnj7qkXSEis3BbgnwBY42uolGg7lPbusmAMWVDYRqKMApQ=="
          },
          {
            "name": "lock",
            "in": "query",
            "description": "Return entities matching given lock status.",
            "schema": {
              "type": "array",
              "items": {
                "$ref": "#/components/schemas/Core_LockStatus"
              }
            },
            "example": [
              "Locked",
              "Unlocked"
            ]
          },
          {
            "name": "metadata.createdBy",
            "in": "query",
            "description": "Return entities that were created by matching user.",
            "schema": {
              "type": "string",
              "format": "uuid"
            },
            "example": "fdeeeb4b-f987-4ec4-9880-1eb280581d49"
          },
          {
            "name": "metadata.lastModifiedBy",
            "in": "query",
            "description": "Return entities that were last modified by matching user.",
            "schema": {
              "type": "string",
              "format": "uuid"
            },
            "example": "90c4cf2f-ebe0-4bf7-91cd-4c45cd02277b"
          },
          {
            "name": "metadata.description",
            "in": "query",
            "description": "Return entities with descriptions that contains or equals to provided description.",
            "schema": {
              "minLength": 0,
              "type": "string"
            },
            "example": "description1"
          },
          {
            "name": "metadata.customProperties",
            "in": "query",
            "description": "Return entities that contains provided custom properties.",
            "schema": {
              "type": "array",
              "items": {
                "type": "string"
              }
            },
            "example": [
              "key1:value1",
              "key2:value2"
            ]
          },
          {
            "name": "additionalDetails.processingStatus",
            "in": "query",
            "description": "Return entities matching given processing status.",
            "schema": {
              "$ref": "#/components/schemas/Core_VaultProcessingStatus"
            },
            "example": "Pending"
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_VaultsCollection"
                }
              }
            }
          },
          "400": {
            "description": "Invalid value for: query parameter limit, Invalid value for: query parameter startingAfter, Invalid value for: query parameter sortBy, Invalid value for: query parameter sortOrder, Invalid value for: query parameter alias, Invalid value for: query parameter publicKey, Invalid value for: query parameter lock, Invalid value for: query parameter metadata.createdBy, Invalid value for: query parameter metadata.lastModifiedBy, Invalid value for: query parameter metadata.description, Invalid value for: query parameter metadata.customProperties, Invalid value for: query parameter additionalDetails.processingStatus",
            "content": {
              "text/plain": {
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/vaults/{vaultId}": {
      "get": {
        "tags": [
          "Vaults"
        ],
        "summary": "Get vault details",
        "operationId": "getVault",
        "parameters": [
          {
            "name": "vaultId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ApiVault"
                }
              }
            }
          },
          "400": {
            "description": "Invalid value for: path parameter vaultId",
            "content": {
              "text/plain": {
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Entity or Domain not found (EntityNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/domains/{domainId}/policies": {
      "get": {
        "tags": [
          "Policies"
        ],
        "summary": "List policies",
        "operationId": "getPolicies",
        "parameters": [
          {
            "name": "domainId",
            "in": "path",
            "description": "Unique identifier for the domain.",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "limit",
            "in": "query",
            "description": "The number of entities to return.",
            "schema": {
              "maximum": 100,
              "minimum": 1,
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "startingAfter",
            "in": "query",
            "description": "Entity id used to the determine beginning of query results.",
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "sortBy",
            "in": "query",
            "description": "Property name used to sort the query results.",
            "schema": {
              "enum": [
                "id",
                "alias",
                "rank",
                "scope",
                "lock",
                "metadata.createdAt",
                "metadata.lastModifiedAt"
              ],
              "type": "string"
            }
          },
          {
            "name": "sortOrder",
            "in": "query",
            "description": "Sort order applied to the query results.",
            "schema": {
              "$ref": "#/components/schemas/Core_SortOrder"
            }
          },
          {
            "name": "alias",
            "in": "query",
            "description": "Return entities with aliases that contains or equals to provided alias.",
            "schema": {
              "minLength": 1,
              "type": "string"
            },
            "example": "alias1"
          },
          {
            "name": "intentTypes",
            "in": "query",
            "description": "Return entities matching any of given intent types.",
            "schema": {
              "type": "array",
              "items": {
                "$ref": "#/components/schemas/Core_IntentType"
              }
            },
            "example": [
              "v0_UnlockPolicy",
              "v0_UpdatePolicy"
            ]
          },
          {
            "name": "scope",
            "in": "query",
            "description": "Return entities matching given policy scope.",
            "schema": {
              "$ref": "#/components/schemas/Core_PolicyScope"
            },
            "example": "Descendants"
          },
          {
            "name": "scriptingEngine",
            "in": "query",
            "description": "Return entities matching given scripting engine.",
            "schema": {
              "$ref": "#/components/schemas/Core_ScriptingEngine"
            },
            "example": "Javascript_v0"
          },
          {
            "name": "metadata.createdBy",
            "in": "query",
            "description": "Return entities that were created by matching user.",
            "schema": {
              "type": "string",
              "format": "uuid"
            },
            "example": "fdeeeb4b-f987-4ec4-9880-1eb280581d49"
          },
          {
            "name": "metadata.lastModifiedBy",
            "in": "query",
            "description": "Return entities that were last modified by matching user.",
            "schema": {
              "type": "string",
              "format": "uuid"
            },
            "example": "90c4cf2f-ebe0-4bf7-91cd-4c45cd02277b"
          },
          {
            "name": "metadata.description",
            "in": "query",
            "description": "Return entities with descriptions that contains or equals to provided description.",
            "schema": {
              "minLength": 0,
              "type": "string"
            },
            "example": "description1"
          },
          {
            "name": "metadata.customProperties",
            "in": "query",
            "description": "Return entities that contains provided custom properties.",
            "schema": {
              "type": "array",
              "items": {
                "type": "string"
              }
            },
            "example": [
              "key1:value1",
              "key2:value2"
            ]
          },
          {
            "name": "lock",
            "in": "query",
            "description": "Return entities matching given lock status.",
            "schema": {
              "type": "array",
              "items": {
                "$ref": "#/components/schemas/Core_LockStatus"
              }
            },
            "example": [
              "Locked",
              "Unlocked"
            ]
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_TrustedPoliciesCollection"
                }
              }
            }
          },
          "400": {
            "description": "Invalid value for: path parameter domainId, Invalid value for: query parameter limit, Invalid value for: query parameter startingAfter, Invalid value for: query parameter sortBy, Invalid value for: query parameter sortOrder, Invalid value for: query parameter alias, Invalid value for: query parameter intentTypes, Invalid value for: query parameter scope, Invalid value for: query parameter scriptingEngine, Invalid value for: query parameter metadata.createdBy, Invalid value for: query parameter metadata.lastModifiedBy, Invalid value for: query parameter metadata.description, Invalid value for: query parameter metadata.customProperties, Invalid value for: query parameter lock",
            "content": {
              "text/plain": {
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Entity or Domain not found (EntityNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/domains/{domainId}/policies/{policyId}": {
      "get": {
        "tags": [
          "Policies"
        ],
        "summary": "Get policy details",
        "operationId": "getPolicy",
        "parameters": [
          {
            "name": "domainId",
            "in": "path",
            "description": "Unique identifier for the domain.",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "policyId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_TrustedPolicy"
                }
              }
            }
          },
          "400": {
            "description": "Invalid value for: path parameter domainId, Invalid value for: path parameter policyId",
            "content": {
              "text/plain": {
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Entity or Domain not found (EntityNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/domains/{domainId}/users": {
      "get": {
        "tags": [
          "Users"
        ],
        "summary": "List users",
        "operationId": "getUsers",
        "parameters": [
          {
            "name": "domainId",
            "in": "path",
            "description": "Unique identifier for the domain.",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "limit",
            "in": "query",
            "description": "The number of entities to return.",
            "schema": {
              "maximum": 100,
              "minimum": 1,
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "startingAfter",
            "in": "query",
            "description": "Entity id used to the determine beginning of query results.",
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "sortBy",
            "in": "query",
            "description": "Property name used to sort the query results.",
            "schema": {
              "enum": [
                "id",
                "alias",
                "lock",
                "metadata.createdAt",
                "metadata.lastModifiedAt"
              ],
              "type": "string"
            }
          },
          {
            "name": "sortOrder",
            "in": "query",
            "description": "Sort order applied to the query results.",
            "schema": {
              "$ref": "#/components/schemas/Core_SortOrder"
            }
          },
          {
            "name": "alias",
            "in": "query",
            "description": "Return entities matching given alias.",
            "schema": {
              "minLength": 1,
              "type": "string"
            },
            "example": "alias1"
          },
          {
            "name": "publicKey",
            "in": "query",
            "description": "Return entities matching given public key. It should be provided in Base64 format.",
            "schema": {
              "minLength": 1,
              "type": "string"
            },
            "example": "MFkwEwYHKoZIzj0CAQYIKoZIzj0DAQcDQgAENYOHIq0Pgg5ERTQOahVK3I45+efvsRvw1rcyk+oqpnj7qkXSEis3BbgnwBY42uolGg7lPbusmAMWVDYRqKMApQ=="
          },
          {
            "name": "roles",
            "in": "query",
            "description": "Return entities that are assigned to roles.",
            "deprecated": true,
            "schema": {
              "type": "array",
              "items": {
                "minLength": 1,
                "type": "string"
              }
            },
            "example": [
              "admin",
              "testUser"
            ]
          },
          {
            "name": "roles[]",
            "in": "query",
            "description": "Return entities that are assigned to at least all the roles provided in the array.",
            "schema": {
              "type": "array",
              "items": {
                "type": "string"
              }
            },
            "example": [
              "admin,testUser",
              "editor"
            ]
          },
          {
            "name": "lock",
            "in": "query",
            "description": "Return entities matching given lock status.",
            "schema": {
              "type": "array",
              "items": {
                "$ref": "#/components/schemas/Core_LockStatus"
              }
            },
            "example": [
              "Locked",
              "Unlocked"
            ]
          },
          {
            "name": "metadata.createdBy",
            "in": "query",
            "description": "Return entities that were created by matching user.",
            "schema": {
              "type": "string",
              "format": "uuid"
            },
            "example": "fdeeeb4b-f987-4ec4-9880-1eb280581d49"
          },
          {
            "name": "metadata.lastModifiedBy",
            "in": "query",
            "description": "Return entities that were last modified by matching user.",
            "schema": {
              "type": "string",
              "format": "uuid"
            },
            "example": "90c4cf2f-ebe0-4bf7-91cd-4c45cd02277b"
          },
          {
            "name": "metadata.description",
            "in": "query",
            "description": "Return entities with descriptions that contains or equals to provided description.",
            "schema": {
              "minLength": 0,
              "type": "string"
            },
            "example": "description1"
          },
          {
            "name": "metadata.customProperties",
            "in": "query",
            "description": "Return entities that contains provided custom properties.",
            "schema": {
              "type": "array",
              "items": {
                "type": "string"
              }
            },
            "example": [
              "key1:value1",
              "key2:value2"
            ]
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_TrustedUsersCollection"
                }
              }
            }
          },
          "400": {
            "description": "Invalid value for: path parameter domainId, Invalid value for: query parameter limit, Invalid value for: query parameter startingAfter, Invalid value for: query parameter sortBy, Invalid value for: query parameter sortOrder, Invalid value for: query parameter alias, Invalid value for: query parameter publicKey, Invalid value for: query parameter roles, Invalid value for: query parameter roles[], Invalid value for: query parameter lock, Invalid value for: query parameter metadata.createdBy, Invalid value for: query parameter metadata.lastModifiedBy, Invalid value for: query parameter metadata.description, Invalid value for: query parameter metadata.customProperties",
            "content": {
              "text/plain": {
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Entity or Domain not found (EntityNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/domains/{domainId}/users/roles": {
      "get": {
        "tags": [
          "Users"
        ],
        "summary": "Get known users roles",
        "operationId": "getKnownUserRoles",
        "parameters": [
          {
            "name": "domainId",
            "in": "path",
            "description": "Unique identifier for the domain.",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ApiRoles"
                }
              }
            }
          },
          "400": {
            "description": "Invalid value for: path parameter domainId",
            "content": {
              "text/plain": {
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Entity or Domain not found (EntityNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/domains/{domainId}/users/{userId}": {
      "get": {
        "tags": [
          "Users"
        ],
        "summary": "Get user details",
        "operationId": "getUser",
        "parameters": [
          {
            "name": "domainId",
            "in": "path",
            "description": "Unique identifier for the domain.",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "userId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_TrustedUser"
                }
              }
            }
          },
          "400": {
            "description": "Invalid value for: path parameter domainId, Invalid value for: path parameter userId",
            "content": {
              "text/plain": {
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Entity or Domain not found (EntityNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/me": {
      "get": {
        "tags": [
          "Users"
        ],
        "summary": "List users belonging to the same public key",
        "operationId": "getMe",
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_MeReference"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError); User not authorized (UnauthorizedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/domains/{domainId}/accounts": {
      "get": {
        "tags": [
          "Accounts"
        ],
        "summary": "List accounts",
        "operationId": "getAccounts",
        "parameters": [
          {
            "name": "domainId",
            "in": "path",
            "description": "Unique identifier for the domain.",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "limit",
            "in": "query",
            "description": "The number of entities to return.",
            "schema": {
              "maximum": 100,
              "minimum": 1,
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "startingAfter",
            "in": "query",
            "description": "Entity id used to the determine beginning of query results.",
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "sortBy",
            "in": "query",
            "description": "Property name used to sort the query results.",
            "schema": {
              "enum": [
                "id",
                "alias",
                "ledgerId",
                "lock",
                "metadata.createdAt",
                "metadata.lastModifiedAt"
              ],
              "type": "string"
            }
          },
          {
            "name": "sortOrder",
            "in": "query",
            "description": "Sort order applied to the query results.",
            "schema": {
              "$ref": "#/components/schemas/Core_SortOrder"
            }
          },
          {
            "name": "ledgerId",
            "in": "query",
            "description": "Return entities matching given default ledger id.",
            "schema": {
              "minLength": 1,
              "type": "string"
            },
            "example": "1234567"
          },
          {
            "name": "alias",
            "in": "query",
            "description": "Return entities with aliases that contains or equals to provided alias.",
            "schema": {
              "minLength": 1,
              "type": "string"
            },
            "example": "alias1"
          },
          {
            "name": "providerDetails.vaultId",
            "in": "query",
            "description": "Return entities matching given vault id.",
            "schema": {
              "type": "string",
              "format": "uuid"
            },
            "example": "8e92eb53-40e7-4809-bb52-7e7b3b41a4be"
          },
          {
            "name": "metadata.createdBy",
            "in": "query",
            "description": "Return entities that were created by matching user.",
            "schema": {
              "type": "string",
              "format": "uuid"
            },
            "example": "fdeeeb4b-f987-4ec4-9880-1eb280581d49"
          },
          {
            "name": "metadata.lastModifiedBy",
            "in": "query",
            "description": "Return entities that were last modified by matching user.",
            "schema": {
              "type": "string",
              "format": "uuid"
            },
            "example": "90c4cf2f-ebe0-4bf7-91cd-4c45cd02277b"
          },
          {
            "name": "metadata.description",
            "in": "query",
            "description": "Return entities with descriptions that contains or equals to provided description.",
            "schema": {
              "minLength": 0,
              "type": "string"
            },
            "example": "description1"
          },
          {
            "name": "metadata.customProperties",
            "in": "query",
            "description": "Return entities that contains provided custom properties.",
            "schema": {
              "type": "array",
              "items": {
                "type": "string"
              }
            },
            "example": [
              "key1:value1",
              "key2:value2"
            ]
          },
          {
            "name": "lock",
            "in": "query",
            "description": "Return entities matching given lock status(/-es).",
            "schema": {
              "type": "array",
              "items": {
                "$ref": "#/components/schemas/Core_LockStatus"
              }
            },
            "example": [
              "Locked",
              "Archived"
            ]
          },
          {
            "name": "additionalDetails.processingStatus",
            "in": "query",
            "description": "Return entities matching given processing status.",
            "deprecated": true,
            "schema": {
              "$ref": "#/components/schemas/Core_AccountProcessingStatus"
            },
            "example": "Completed"
          },
          {
            "name": "additionalDetails.ledgers.ledgerId",
            "in": "query",
            "description": "Return entities given ledger id.",
            "schema": {
              "type": "array",
              "items": {
                "minLength": 1,
                "type": "string"
              }
            },
            "example": [
              "bitcoin",
              "bitcoin-testnet"
            ]
          },
          {
            "name": "additionalDetails.ledgers.status",
            "in": "query",
            "description": "Return entities having a ledger matching given status.",
            "schema": {
              "type": "array",
              "items": {
                "$ref": "#/components/schemas/Core_AccountLedgerStatus"
              }
            },
            "example": [
              "Activating",
              "Activated"
            ]
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_AccountsCollection"
                }
              }
            }
          },
          "400": {
            "description": "One of: Domain locked (DomainLockedError); Requester locked (RequesterLockedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Entity or Domain not found (EntityNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/addresses": {
      "get": {
        "tags": [
          "Accounts"
        ],
        "summary": "Get address from all generated addresses across domains",
        "operationId": "getAllDomainsAddresses",
        "parameters": [
          {
            "name": "address",
            "in": "query",
            "description": "Address required and only one for getting entities matching this address.",
            "required": true,
            "schema": {
              "minLength": 1,
              "type": "string"
            },
            "example": "someLedgerAddress"
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_AddressReferenceCollection"
                }
              }
            }
          },
          "400": {
            "description": "Invalid value for: query parameter address",
            "content": {
              "text/plain": {
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/domains/{domainId}/compliance-configurations": {
      "get": {
        "tags": [
          "Accounts"
        ],
        "summary": "List compliance configurations for all accounts in a domain",
        "operationId": "listComplianceConfigurations",
        "parameters": [
          {
            "name": "domainId",
            "in": "path",
            "description": "Unique identifier for the domain.",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "limit",
            "in": "query",
            "description": "The number of entities to return.",
            "schema": {
              "maximum": 100,
              "minimum": 1,
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "startingAfter",
            "in": "query",
            "description": "Entity id used to the determine beginning of query results.",
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ComplianceConfigurationsCollection"
                }
              }
            }
          },
          "400": {
            "description": "One of: Domain locked (DomainLockedError); Requester locked (RequesterLockedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Entity or Domain not found (EntityNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/domains/{domainId}/accounts/{accountId}/compliance-configuration": {
      "get": {
        "tags": [
          "Accounts"
        ],
        "summary": "Get compliance configuration for an account",
        "operationId": "getComplianceConfiguration",
        "parameters": [
          {
            "name": "domainId",
            "in": "path",
            "description": "Unique identifier for the domain.",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "accountId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ComplianceConfiguration"
                }
              }
            }
          },
          "400": {
            "description": "One of: Domain locked (DomainLockedError); Requester locked (RequesterLockedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Entity or Domain not found (EntityNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      },
      "put": {
        "tags": [
          "Accounts"
        ],
        "summary": "Create or update compliance configuration for an account",
        "operationId": "upsertComplianceConfiguration",
        "parameters": [
          {
            "name": "domainId",
            "in": "path",
            "description": "Unique identifier for the domain.",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "accountId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/Core_UpsertComplianceConfigurationRequest"
              }
            }
          },
          "required": true
        },
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ComplianceConfiguration"
                }
              }
            }
          },
          "400": {
            "description": "One of: Domain locked (DomainLockedError); Invalid request (InvalidRequestError); Requester locked (RequesterLockedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Entity or Domain not found (EntityNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/domains/{domainId}/accounts/{accountId}": {
      "get": {
        "tags": [
          "Accounts"
        ],
        "summary": "Get account details",
        "operationId": "getAccount",
        "parameters": [
          {
            "name": "domainId",
            "in": "path",
            "description": "Unique identifier for the domain.",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "accountId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ApiAccount"
                }
              }
            }
          },
          "400": {
            "description": "One of: Domain locked (DomainLockedError); Requester locked (RequesterLockedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Entity or Domain not found (EntityNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/domains/{domainId}/accounts/{accountId}/addresses": {
      "get": {
        "tags": [
          "Accounts"
        ],
        "summary": "Retrieve all generated addresses",
        "operationId": "getAddresses",
        "parameters": [
          {
            "name": "domainId",
            "in": "path",
            "description": "Unique identifier for the domain.",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "accountId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "limit",
            "in": "query",
            "description": "The number of entities to return.",
            "schema": {
              "maximum": 100,
              "minimum": 1,
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "startingAfter",
            "in": "query",
            "description": "AccountAddressId id used to the determine beginning of query results.",
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "sortBy",
            "in": "query",
            "description": "Property name used to sort the query results.",
            "schema": {
              "enum": [
                "id",
                "ledgerId",
                "address",
                "createdAt",
                "scope"
              ],
              "type": "string"
            }
          },
          {
            "name": "sortOrder",
            "in": "query",
            "description": "Sort order applied to the query results.",
            "schema": {
              "$ref": "#/components/schemas/Core_SortOrder"
            }
          },
          {
            "name": "ledgerId",
            "in": "query",
            "description": "Return addresses matching given ledgers.",
            "schema": {
              "type": "array",
              "items": {
                "minLength": 1,
                "type": "string"
              }
            },
            "example": [
              "1234567",
              "abcdefg"
            ]
          },
          {
            "name": "lastOnly",
            "in": "query",
            "description": "Return only last addresses for matching ledgers.",
            "schema": {
              "type": "boolean"
            },
            "example": "true"
          },
          {
            "name": "scope",
            "in": "query",
            "description": "Return addresses matching given scopes.",
            "schema": {
              "type": "array",
              "items": {
                "$ref": "#/components/schemas/Core_AccountAddressScope"
              }
            },
            "example": [
              "External"
            ]
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_AddressesCollection"
                }
              }
            }
          },
          "400": {
            "description": "One of: Domain locked (DomainLockedError); Requester locked (RequesterLockedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Entity or Domain not found (EntityNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "409": {
            "description": "One of: Account not processed (AccountNotProcessed); Account not ready yet (AccountNotReady)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      },
      "post": {
        "tags": [
          "Accounts"
        ],
        "summary": "Generate new account external address",
        "operationId": "generateNewExternalAddressDeprecated",
        "parameters": [
          {
            "name": "domainId",
            "in": "path",
            "description": "Unique identifier for the domain.",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "accountId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "ledgerId",
            "in": "query",
            "description": "Return entities matching given ledger id.",
            "schema": {
              "minLength": 1,
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_AccountAddress"
                }
              }
            }
          },
          "400": {
            "description": "One of: Domain locked (DomainLockedError); Requester locked (RequesterLockedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Entity or Domain not found (EntityNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "409": {
            "description": "One of: Account new addresses exhausted (AccountAddressesExhausted); Account not processed (AccountNotProcessed); Account not ready yet (AccountNotReady)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "deprecated": true,
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/domains/{domainId}/accounts/{accountId}/addresses/{ledgerId}": {
      "post": {
        "tags": [
          "Accounts"
        ],
        "summary": "Generate new account external address",
        "operationId": "generateNewExternalAddress",
        "parameters": [
          {
            "name": "domainId",
            "in": "path",
            "description": "Unique identifier for the domain.",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "accountId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "ledgerId",
            "in": "path",
            "required": true,
            "schema": {
              "minLength": 1,
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_AccountAddress"
                }
              }
            }
          },
          "400": {
            "description": "One of: Domain locked (DomainLockedError); Requester locked (RequesterLockedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Entity or Domain not found (EntityNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "409": {
            "description": "One of: Account new addresses exhausted (AccountAddressesExhausted); Account not processed (AccountNotProcessed); Account not ready yet (AccountNotReady)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/domains/{domainId}/accounts/{accountId}/addresses/latest": {
      "get": {
        "tags": [
          "Accounts"
        ],
        "summary": "Retrieve latest external address",
        "operationId": "getLatestAddress",
        "parameters": [
          {
            "name": "domainId",
            "in": "path",
            "description": "Unique identifier for the domain.",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "accountId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "ledgerId",
            "in": "query",
            "description": "Return entities matching given ledger id.",
            "schema": {
              "minLength": 1,
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_AccountAddress"
                }
              }
            }
          },
          "400": {
            "description": "One of: Domain locked (DomainLockedError); Requester locked (RequesterLockedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Entity or Domain not found (EntityNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "deprecated": true,
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/domains/{domainId}/accounts/{accountId}/addresses/{accountAddressId}": {
      "get": {
        "tags": [
          "Accounts"
        ],
        "summary": "Retrieve account address",
        "operationId": "getAccountAddress",
        "parameters": [
          {
            "name": "domainId",
            "in": "path",
            "description": "Unique identifier for the domain.",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "accountId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "accountAddressId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_AccountAddress"
                }
              }
            }
          },
          "400": {
            "description": "One of: Domain locked (DomainLockedError); Requester locked (RequesterLockedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Entity or Domain not found (EntityNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "409": {
            "description": "One of: Account not processed (AccountNotProcessed); Account not ready yet (AccountNotReady)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/domains/{domainId}/accounts/{accountId}/confirmed-balance/{tickerId}": {
      "get": {
        "tags": [
          "Accounts"
        ],
        "summary": "Get account confirmed balance for a specific ticker",
        "operationId": "getAccountConfirmedBalance",
        "parameters": [
          {
            "name": "domainId",
            "in": "path",
            "description": "Unique identifier for the domain.",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "accountId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "tickerId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_BalanceWithConfirmedAmount"
                }
              }
            }
          },
          "400": {
            "description": "Balance not found (BalanceNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Entity or Domain not found (EntityNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "deprecated": true,
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/domains/{domainId}/accounts/{accountId}/balances": {
      "get": {
        "tags": [
          "Accounts"
        ],
        "summary": "Get account balances",
        "operationId": "getAccountBalances",
        "parameters": [
          {
            "name": "domainId",
            "in": "path",
            "description": "Unique identifier for the domain.",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "accountId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "limit",
            "in": "query",
            "description": "The number of entities to return.",
            "schema": {
              "maximum": 100,
              "minimum": 1,
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "startingAfter",
            "in": "query",
            "description": "Ticker id used to the determine beginning of query results.",
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "sortBy",
            "in": "query",
            "description": "Property name used to sort the query results.",
            "schema": {
              "enum": [
                "id",
                "tickerId",
                "totalAmount",
                "reservedAmount",
                "quarantinedAmount",
                "lastUpdatedAt"
              ],
              "type": "string"
            }
          },
          {
            "name": "sortOrder",
            "in": "query",
            "description": "Sort order applied to the query results.",
            "schema": {
              "$ref": "#/components/schemas/Core_SortOrder"
            }
          },
          {
            "name": "ticker.id",
            "in": "query",
            "description": "Return balances of tickers with this id for the account.",
            "schema": {
              "type": "array",
              "items": {
                "type": "string",
                "format": "uuid"
              }
            },
            "example": [
              "4e066dff-e2aa-45ec-9398-1140e9aa98d9",
              "f0390b50-1abd-47df-9580-b69a1298226a"
            ]
          },
          {
            "name": "ticker.name",
            "in": "query",
            "description": "Return balances of tickers with this name for the account.",
            "schema": {
              "type": "array",
              "items": {
                "minLength": 1,
                "type": "string"
              }
            },
            "example": [
              "mati",
              "nft"
            ]
          },
          {
            "name": "ticker.symbol",
            "in": "query",
            "description": "Return balances of tickers with this symbol for the account.",
            "schema": {
              "type": "array",
              "items": {
                "minLength": 1,
                "type": "string"
              }
            },
            "example": [
              "btc",
              "doge"
            ]
          },
          {
            "name": "ticker.ledgerId",
            "in": "query",
            "description": "Return balances matching given ledger ids.",
            "schema": {
              "type": "array",
              "items": {
                "minLength": 1,
                "type": "string"
              }
            },
            "example": [
              "bitcoin",
              "bitcoin-testnet"
            ]
          },
          {
            "name": "ticker.validationStatus",
            "in": "query",
            "description": "Return transfers with ticker matching the requested validation status",
            "schema": {
              "$ref": "#/components/schemas/Core_TickerValidationStatusFilter"
            },
            "example": "Validated"
          },
          {
            "name": "ticker.lock",
            "in": "query",
            "description": "Return transfers with ticker matching given lock status.",
            "schema": {
              "type": "array",
              "items": {
                "$ref": "#/components/schemas/Core_LockStatus"
              }
            },
            "example": [
              "Locked",
              "Archived"
            ]
          }
        ],
        "responses": {
          "200": {
            "description": "",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_BalancesCollection"
                }
              }
            }
          },
          "400": {
            "description": "One of: Domain locked (DomainLockedError); Requester locked (RequesterLockedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Entity or Domain not found (EntityNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "409": {
            "description": "One of: Account not processed (AccountNotProcessed); Account not ready yet (AccountNotReady)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/domains/{domainId}/accounts/{accountId}/balances/refresh": {
      "post": {
        "tags": [
          "Accounts"
        ],
        "summary": "Update account balances forcefully",
        "operationId": "forceUpdateAccountBalances",
        "parameters": [
          {
            "name": "domainId",
            "in": "path",
            "description": "Unique identifier for the domain.",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "accountId",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "ledgerId",
            "in": "query",
            "description": "Updates only balances for native and validated tickers with the given ledger id. Non-validated token tickers are excluded. Reduces execution time.",
            "schema": {
              "minLength": 1,
              "type": "string"
            }
          },
          {
            "name": "tickerId",
            "in": "query",
            "description": "Updates only balances with the given ticker id. Reduces execution time.",
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          }
        ],
        "responses": {
          "200": {
            "description": ""
          },
          "400": {
            "description": "One of: Domain locked (DomainLockedError); Requester locked (RequesterLockedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "401": {
            "description": "One of: Invalid JWT (InvalidJwtError); User not authorized (PermissionDeniedError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "404": {
            "description": "Entity or Domain not found (EntityNotFoundError)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          },
          "409": {
            "description": "One of: Account not processed (AccountNotProcessed); Account not ready yet (AccountNotReady)",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/Core_ErrorMessage"
                }
              }
            }
          }
        },
        "security": [
          {
            "httpAuth": []
          }
        ]
      }
    },
    "/v1/domains/{domainId}/endpoints": {
      "get": {
        "tags": [
          "Endpoints"
        ],
        "summary": "List endpoints",
        "operationId": "getEndpoints",
        "parameters": [
          {
            "name": "domainId",
            "in": "path",
            "description": "Unique identifier for the domain.",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "limit",
            "in": "query",
            "description": "The number of entities to return.",
            "schema": {
              "maximum": 100,
              "minimum": 1,
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "startingAfter",
            "in": "query",
            "description": "Entity id used to the determine beginning of query results.",
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          },
          {
            "name": "sortBy",
            "in": "query",
            "description": "Property name used to sort the query results.",
            "schema": {
              "enum": [
                "id",
                "alias",
                "address",
                "ledgerId",
                "trustScore",
                "lock",
                "metadata.createdAt",
                "metadata.lastModifiedAt"
              ],
              "type": "string"
            }
          },
          {
            "name": "sortOrder",
            "in": "query",
            "description": "Sort order applied to the query results.",
            "schema": {
              "$ref": "#/components/schemas/Core_SortOrder"
            }
          },
          {
            "name": "ledgerId",
            "in": "query",
            "description": "Return entities matching given ledger id.",
            "schema": {
              "type": "array",
              "items": {
                "minLength": 1,
                "type": "string"
[...]
